From a6f26b85b37583ddb43df2217f1774a5cdf90e8d Mon Sep 17 00:00:00 2001
From: Geza Lore <gezalore@gmail.com>
Date: Tue, 2 Sep 2025 16:50:40 +0100
Subject: [PATCH] Internals: Improve DFG implementation details (#6355)

Large scale refactoring to simplify some of the more obtuse internals of
DFG. Remove multiple redundant internal APIs, simplify representation of
variables, fix potential unsoundness in circular decomposition. No
functional change intended.
---
 src/V3AstNodeOther.h                          |   2 +-
 src/V3Cfg.cpp                                 |   1 +
 src/V3Cfg.h                                   |  20 +-
 src/V3CfgBuilder.cpp                          |   2 +-
 src/V3Dfg.cpp                                 | 432 +++------
 src/V3Dfg.h                                   | 890 ++++++------------
 src/V3DfgAstToDfg.cpp                         |  19 +-
 src/V3DfgBreakCycles.cpp                      | 134 +--
 src/V3DfgCache.h                              |  26 +-
 src/V3DfgColorSCCs.cpp                        |   7 +-
 src/V3DfgDecomposition.cpp                    | 210 +++--
 src/V3DfgDfgToAst.cpp                         | 153 ++-
 src/V3DfgOptimizer.cpp                        |   2 +-
 src/V3DfgPasses.cpp                           |  30 +-
 src/V3DfgPatternStats.h                       |   3 +-
 src/V3DfgPeephole.cpp                         |  86 +-
 src/V3DfgRegularize.cpp                       |   2 +-
 src/V3DfgSynthesize.cpp                       | 525 ++++++-----
 src/V3DfgVertices.h                           | 572 ++++++-----
 src/astgen                                    |  54 +-
 src/cppcheck-suppressions.txt                 |   4 +-
 test_regress/t/t_dfg_synthesis_pre_inline.cpp |  60 ++
 test_regress/t/t_dfg_synthesis_pre_inline.py  | 100 ++
 test_regress/t/t_dfg_synthesis_pre_inline.v   |  34 +
 24 files changed, 1699 insertions(+), 1669 deletions(-)
 create mode 100644 test_regress/t/t_dfg_synthesis_pre_inline.cpp
 create mode 100755 test_regress/t/t_dfg_synthesis_pre_inline.py
 create mode 100644 test_regress/t/t_dfg_synthesis_pre_inline.v

diff --git a/src/V3AstNodeOther.h b/src/V3AstNodeOther.h
index 895bc6063fb..d2681c57e89 100644
--- a/src/V3AstNodeOther.h
+++ b/src/V3AstNodeOther.h
@@ -2617,7 +2617,7 @@ class AstAlways final : public AstNodeProcedure {
     const VAlwaysKwd m_keyword;
 
 public:
-    AstAlways(FileLine* fl, VAlwaysKwd keyword, AstSenTree* sentreep, AstNode* stmtsp)
+    AstAlways(FileLine* fl, VAlwaysKwd keyword, AstSenTree* sentreep, AstNode* stmtsp = nullptr)
         : ASTGEN_SUPER_Always(fl, stmtsp)
         , m_keyword{keyword} {
         this->sentreep(sentreep);
diff --git a/src/V3Cfg.cpp b/src/V3Cfg.cpp
index e671cfd59f5..34a870a602a 100644
--- a/src/V3Cfg.cpp
+++ b/src/V3Cfg.cpp
@@ -115,6 +115,7 @@ void CfgGraph::rpoBlocks() {
     // Assign edge IDs
     size_t edgeCount = 0;
     for (V3GraphVertex& v : vertices()) {
+        // cppcheck-suppress constVariableReference // cppcheck is wrong
         for (V3GraphEdge& e : v.outEdges()) static_cast<CfgEdge&>(e).m_id = edgeCount++;
     }
     UASSERT_OBJ(edgeCount == m_nEdges, m_enterp, "Inconsistent edge count");
diff --git a/src/V3Cfg.h b/src/V3Cfg.h
index 51c4266591c..ef3e2a8709b 100644
--- a/src/V3Cfg.h
+++ b/src/V3Cfg.h
@@ -92,15 +92,12 @@ class CfgBlock final : public V3GraphVertex {
 
     // STATE
     CfgGraph* const m_cfgp;  // The control flow graph this CfgBlock is under
-    size_t m_rpoNumber;  // Reverse post-order number and unique ID of this CfgBlock
+    size_t m_rpoNumber = 0;  // Reverse post-order number and unique ID of this CfgBlock
 
     // V3GraphEdge::user() is set to the unique id by CfgBuilder
     std::vector<AstNodeStmt*> m_stmtps;  // statements in this CfgBlock
 
     // PRIVATE METHODS
-    // ID (reverse post-order numpber) of this block
-    inline size_t id();
-    inline size_t id() const;
 
     // CONSTRUCTOR/DESTRUCTOR - via CfgGraph only
     inline explicit CfgBlock(CfgGraph* cfgp);
@@ -109,6 +106,10 @@ class CfgBlock final : public V3GraphVertex {
 public:
     // PUBLIC METHODS
 
+    // ID (reverse post-order number) of this block
+    inline size_t id();
+    inline size_t id() const;
+
     // Is this the entry block of the CFG?
     bool isEnter() const { return inEmpty(); }
     // Is this the exit block of the CFG?
@@ -185,19 +186,20 @@ class CfgEdge final : public V3GraphEdge {
 
     // STATE - Immutable after construction, set by CfgBuilder
     CfgGraph* const m_cfgp;  // The control flow graph this CfgEdge is under
-    size_t m_id;  // Unique ID of this vertex
+    size_t m_id = 0;  // Unique ID of this vertex
 
     // PRIVATE METHODS
-    // Unique ID of this CfgEdge - no particular meaning
-    inline size_t id();
-    inline size_t id() const;
 
     // CONSTRUCTOR/DESTRUCTOR - via CfgGraph only
     inline CfgEdge(CfgGraph* graphp, CfgBlock* srcp, CfgBlock* dstp);
     ~CfgEdge() override = default;
 
 public:
-    // METHODS - all const
+    // METHODS
+
+    // Unique ID of this CfgEdge - no particular meaning
+    inline size_t id();
+    inline size_t id() const;
 
     // Source/destination CfgBlock
     const CfgBlock* srcp() const { return static_cast<const CfgBlock*>(fromp()); }
diff --git a/src/V3CfgBuilder.cpp b/src/V3CfgBuilder.cpp
index 407c0aba347..1d5379d81d8 100644
--- a/src/V3CfgBuilder.cpp
+++ b/src/V3CfgBuilder.cpp
@@ -205,7 +205,7 @@ class CfgBuilder final : public VNVisitorConst {
             while (!unreachableps.empty()) {
                 V3GraphVertex* const vtxp = unreachableps.back();
                 unreachableps.pop_back();
-                for (V3GraphEdge& edge : vtxp->outEdges()) {
+                for (const V3GraphEdge& edge : vtxp->outEdges()) {
                     --m_cfgp->m_nEdges;
                     if (edge.top()->inSize1()) unreachableps.emplace_back(edge.top());
                 }
